package com.qx.gpsp;

import com.qx.gpsp.common.WzException;
import com.qx.gpsp.internal.InternalWzEntityManager;
import com.qx.gpsp.internal.InternalWzEntityPointManager;
import com.qx.gpsp.manager.WzEntityManager;
import com.qx.gpsp.manager.WzEntityPointManager;

public class WzQxyzClient {
	
	private String appKey;
	private String appSecret;
	
	private InternalWzEntityManager internalWzEntityManager;
	private InternalWzEntityPointManager internalWzEntityPointManager;
	
	/**
     * 构造一个千寻云踪Client实例
     *
     * @param appKey 千寻位置应用Key
     * @param appSecret 千寻位置应用Secret
	 * @throws WzException 
     */
	 public WzQxyzClient(String appKey,String appSecret) throws WzException{
		if(appKey == null || appKey.isEmpty())
			throw new WzException(WzException.IllegalArgumentException,"appKey should not be null or empty");
		
		if(appSecret == null || appSecret.isEmpty())
			throw new WzException(WzException.IllegalArgumentException,"appKey should not be null or empty");
		
		this.appKey = appKey.trim();
		this.appSecret = appSecret.trim();
		
		this.internalWzEntityManager = new InternalWzEntityManager(this.appKey,this.appSecret);
		this.internalWzEntityPointManager = new InternalWzEntityPointManager(this.appKey,this.appSecret);
	}
	
	public WzEntityManager getWzEntityManager(){
		return this.internalWzEntityManager;
	}
	
	public  WzEntityPointManager getWzEntityPointManager(){
		return this.internalWzEntityPointManager;
	}
	
	public void close(){
		this.internalWzEntityManager = null;
		this.internalWzEntityPointManager = null;
	}
}