package com.qx.gpsp.internal;

import java.io.IOException;
import java.io.UnsupportedEncodingException;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;

import org.apache.http.NameValuePair;
import org.apache.http.client.ClientProtocolException;
import org.apache.http.client.entity.UrlEncodedFormEntity;
import org.apache.http.client.methods.CloseableHttpResponse;
import org.apache.http.client.methods.HttpPost;
import org.apache.http.impl.client.CloseableHttpClient;
import org.apache.http.impl.client.HttpClients;
import org.apache.http.message.BasicNameValuePair;

import com.qx.gpsp.auth.HmacSHASignature;
import com.qx.gpsp.common.WzException;

public class WzRequestManager extends InternalWzManager{

	public WzRequestManager(String appKey, String appSecret) {
		super(appKey, appSecret);
		// TODO Auto-generated constructor stub
	}

	public CloseableHttpResponse execute(String apiMethod,Map<String, String> paramMap) throws WzException{
		String apiPath = "/rest/" +apiMethod + "/" + this.getAppKey() + "/0";// API路径
		String timestamp = String.valueOf(System.currentTimeMillis()); 
		String signatureStr = HmacSHASignature.doHmacSHA(apiPath, paramMap, this.getAppSecret(), timestamp);
		String url = this.getServerUrl() + apiPath + "?_sign=" + signatureStr;
		CloseableHttpClient httpClient = HttpClients.createDefault();
		HttpPost request = new HttpPost(url);
		request.setHeader("Accept-Encoding", "gzip, deflate");
		request.setHeader("wz-acs-timestamp", String.valueOf(timestamp));//此处注意加上时间戳
        
      	List<NameValuePair> nvps = new ArrayList<NameValuePair>();
        for (Map.Entry<String, String> entry : paramMap.entrySet()){
             if (entry.getValue() == null) continue;
              	nvps.add(new BasicNameValuePair(entry.getKey(), entry.getValue()));
        }
        //处理中文编码的问题
        try {
        	request.setEntity(new UrlEncodedFormEntity(nvps, "UTF-8"));;
		} catch (UnsupportedEncodingException e){
			e.printStackTrace();
			throw new WzException(WzException.UnsupportedEncodingException,e.getMessage());
		}
        CloseableHttpResponse response = null;
		try {
			response = httpClient.execute(request);
		} catch (ClientProtocolException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
			throw new WzException(WzException.ClientProtocolException,e.getMessage());
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
			throw new WzException(WzException.ClientProtocolException,e.getMessage());
		}
		return response;
	}
}
