package com.qx.gpsp.model;

import java.util.HashMap;
import java.util.Map;

import org.json.JSONObject;

import com.qx.gpsp.common.WzBizType;


public class WzEntity {
	private String bizType = WzBizType.GENERAL;
	
	private String entityName;
	
	private String entityType;
	
	private Map<String, Object> attributes; 
	
	public WzEntity(){
		
	}
	
	public WzEntity(String entityName,String entityType){
		this.setEntityName(entityName);
		this.setEntityType(entityType);
	}
	
	public WzEntity(String bizType,String entityName,String entityType,Map<String,Object> attributes){
		this.setBizType(bizType);
		this.setEntityName(entityName);
		this.setEntityType(entityType);
		this.setAttributes(attributes);
	}
	
	public void setBizType(String bizType){
		this.bizType= bizType;
	}
	
	public String getBizType(){
		return this.bizType;
	}
	
	public void setEntityName(String entityName){
		this.entityName = entityName;
	}
	
	public String getEntityName(){
		return this.entityName;
	}
	
	public void setEntityType(String entityType){
		this.entityType = entityType;
	}
	
	public String getEntityType(){
		return this.entityType;
	}
	
	public void addAttribute(String key,Object value){
		if(this.attributes == null)
			this.attributes = new HashMap<String, Object>();
		this.attributes.put(key, value);
	}
	
	public void removeAttribute(String key){
		if(this.attributes == null)
			return;
		this.attributes.remove(key);
	}
	
	public void setAttributes(Map<String,Object> attributes){
		this.attributes = attributes;
	}
	
	public Map<String,Object> getAttributes(){
		return this.attributes;
	}
	
	public String toString(){
		JSONObject jsonObject = new JSONObject();
		if(this.getBizType() != null)
			jsonObject.put("bizType", this.getBizType());
		if(this.getEntityName() != null)
			jsonObject.put("entityName", this.getEntityName());
		if(this.getBizType() != null)
			jsonObject.put("bizType", this.getBizType());
		if(this.getAttributes() != null && !this.getAttributes().isEmpty())
			jsonObject.put("attributes", this.getAttributes());
		return jsonObject.toString();
	}
}
