package com.qx.gpsp.model;

import java.util.HashMap;
import java.util.Map;

import org.json.JSONObject;

import com.qx.gpsp.common.WzCoordinateType;

public class WzEntityPoint {
	
	private String entityName;
	
	private Double lon;
	
	private Double lat;
	
	private String coordinateType = WzCoordinateType.WGS84;
	
	private Long gnssTime;
	
	private Double speed;
	
	private Double direction;
	
	private Double altitude;
	
	private Map<String,Object> attributes;
	
	public WzEntityPoint(){
		
	}
	
	public WzEntityPoint(String entityName,double lon,double lat,long gnssTime){
		this.setEntityName(entityName);
		this.setLon(lon);
		this.setLat(lat);
		this.setGnssTime(gnssTime);
	}
	
	public WzEntityPoint(double lon,double lat,String coordinateType,long gnssTime,double speed,double direction,
			double altitude,Map<String,Object> attributes){
		this.setEntityName(coordinateType);
		this.setLon(lon);
		this.setLat(lat);
		this.setCoordinateType(coordinateType);
		this.setGnssTime(gnssTime);
		this.setSpeed(speed);
		this.setDirection(direction);
		this.setAltitude(altitude);
		this.setAttributes(attributes);
	}
	
	public void setEntityName(String entityName){
		this.entityName = entityName;
	}
	
	public String getEntityName(){
		return this.entityName;
	}
	
	public void setLon(Double lon){
		this.lon = lon;
	}
	
	public Double getLon(){
		return this.lon;
	}
	
	public void setLat(double lat){
		this.lat = lat;
	}
	
	public Double getLat(){
		return this.lat;
	}
	
	public void setCoordinateType(String coordinateType){
		this.coordinateType = coordinateType;
	}
	
	public String getCoordinateType(){
		return this.coordinateType;
	}
	
	public void setGnssTime(Long gnssTime){
		this.gnssTime = gnssTime;
	}
	
	public Long getGnssTime(){
		return this.gnssTime;
	}
	
	public void setSpeed(Double speed){
		this.speed = speed;
	}
	
	public Double getSpeed(){
		return this.speed;
	}
	
	public void setDirection(double direction){
		this.direction = direction;
	}
	
	public Double getDirection(){
		return this.direction;
	}
	
	public void setAltitude(double altitude){
		this.altitude = altitude;
	}
	
	public Double getAltitude(){
		return this.altitude;
	}
	
	public void setAttributes(Map<String,Object> attributes){
		this.attributes = attributes;
	}
	
	public Map<String,Object> getAttributes(){
		return this.attributes;
	}
	
	public void addAttribute(String key,Object value){
		if(this.attributes == null)
			this.attributes = new HashMap<String,Object>();
		
		this.attributes.put(key, value);
	}
	
	public void removeAttribute(String key){
		if(this.attributes == null)
			return;
		this.attributes.remove(key);
	}
	
	public Object getAttribute(String key){
		if(this.attributes == null)
			return null;
		
		return this.attributes.get(key);
	}
	
	public String toString(){
		JSONObject jsonObject = new JSONObject();
		if(this.getEntityName() != null && !this.getEntityName().isEmpty())
			jsonObject.put("entityName", this.getEntityName());
		if(this.getLon() != null)
			jsonObject.put("lon", this.getLon());
		if(this.getLat() != null)
			jsonObject.put("lat", this.getLat());
		if(this.getCoordinateType() != null && !this.getCoordinateType().isEmpty())
			jsonObject.put("coordinate", this.getCoordinateType());
		if(this.getGnssTime() != null)
			jsonObject.put("gnssTime", this.getGnssTime());
		if(this.getAltitude() != null)
			jsonObject.put("altitude", this.getAltitude()); 
		if(this.getSpeed() != null)
			jsonObject.put("speed", this.getSpeed());
		if(this.getDirection() != null)
			jsonObject.put("direction", this.getDirection());
		if(this.getAttributes() != null && !this.getAttributes().isEmpty())
			jsonObject.put("attributes", this.getAttributes()); 
		return jsonObject.toString();
	}
}