package samples;

import java.util.ArrayList;
import java.util.List;

import com.qx.gpsp.WzQxyzClient;
import com.qx.gpsp.common.WzBizType;
import com.qx.gpsp.common.WzException;
import com.qx.gpsp.manager.WzEntityManager;
import com.qx.gpsp.model.WzEntity;
import com.qx.gpsp.model.result.WzCreateEntityResult;
import com.qx.gpsp.model.result.WzDeleteEntityResult;
import com.qx.gpsp.model.result.WzQueryEntitiesByAppResult;
import com.qx.gpsp.model.result.WzQueryEntitiesResult;
import com.qx.gpsp.model.result.WzQueryEntityResult;
import com.qx.gpsp.model.result.WzUpdateEntityResult;

/**
 * 此示例为实体管理（WzEntityPointManager）的全部函数调用示例
 */
public class Demo_WzEntityManager {
	public static void main(String[] args){
		
		System.out.println("-----------实体管理-begin-----------");
		
		//初始化云踪实例,请替换成您自己的appKey和appSecret
		WzQxyzClient client = null;
		try {
			client = new WzQxyzClient("appKey","appSecret");
		} catch (WzException e1) {
			// TODO Auto-generated catch block
			e1.printStackTrace();
		}
		WzEntityManager wzEntityManager = client.getWzEntityManager();

		String entityName = "实体A";
		
		//创建实体A
		WzEntity wzEntity = new WzEntity();
		wzEntity.setEntityName(entityName);
		wzEntity.setEntityType("电动车");
		wzEntity.addAttribute("color", "黑色");
		wzEntity.addAttribute("driver", "千小寻");
		try {
			WzCreateEntityResult wzCreateEntityResult = wzEntityManager.createEntity(wzEntity);
			if(wzCreateEntityResult.getCode() == 0){
				System.out.println("创建实体成功："+wzCreateEntityResult.getEntityName());
			} else{
				System.out.println("创建实体失败：（"+wzCreateEntityResult.getCode()+"）"+wzCreateEntityResult.getMessage());
			}
		} catch (WzException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
		//查询实体A
		try {
			WzQueryEntityResult wzQueryEntityResult = wzEntityManager.queryEntity(WzBizType.GENERAL, entityName);
			if(wzQueryEntityResult.getCode() == 0){
				WzEntity wzQueryEntity = wzQueryEntityResult.getEntity();
				System.out.println("查询实体成功："+wzQueryEntity.toString());
			} else{
				System.out.println("查询实体失败：（"+wzQueryEntityResult.getCode()+"）"+wzQueryEntityResult.getMessage());
			}
		} catch (WzException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
		//更新实体A
		WzEntity updateEntity = new WzEntity();
		updateEntity.setBizType(WzBizType.GENERAL);
		updateEntity.setEntityName(entityName);
		updateEntity.addAttribute("color", "黑色-更新");
		updateEntity.addAttribute("driver", "千小寻-更新");
		try {
			WzUpdateEntityResult wzUpdateEntityResult = wzEntityManager.updateEntity(updateEntity);
			if(wzUpdateEntityResult.getCode() == 0){
				System.out.println("更新实体成功："+entityName);
			}
			else{
				System.out.println("更新实体失败：（"+wzUpdateEntityResult.getCode()+"）"+wzUpdateEntityResult.getMessage());
			}
		} catch (WzException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
		//查询实体A
		try {
			WzQueryEntityResult wzQueryEntityResult2 = wzEntityManager.queryEntity(WzBizType.GENERAL, entityName);
			if(wzQueryEntityResult2.getCode() == 0){
				WzEntity wzQueryEntity = wzQueryEntityResult2.getEntity();
				System.out.println("查询实体成功："+wzQueryEntity.toString());
			} else{
				System.out.println("查询实体失败：（"+wzQueryEntityResult2.getCode()+"）"+wzQueryEntityResult2.getMessage());
			}
		} catch (WzException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
		//查询多个实体
		List<String> entityNames = new ArrayList<String>();
		entityNames.add(entityName);
		entityNames.add("沪ABCD");
		try {
			WzQueryEntitiesResult wzQueryEntitiesResult = wzEntityManager.queryEntities(WzBizType.GENERAL,entityNames);
			if(wzQueryEntitiesResult.getCode() == 0){
				
				List<WzEntity> wzEntities = wzQueryEntitiesResult.getWzEntities();
				System.out.println("查询多个实体成功:"+wzEntities.toString());
			} else{
				System.out.println("查询多个实体失败：（"+wzQueryEntitiesResult.getCode()+"）"+wzQueryEntitiesResult.getMessage());
			}
		} catch (WzException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
		//查询所有实体
		try {
			WzQueryEntitiesByAppResult wzQueryEntitiesByAppResult = wzEntityManager.queryEntitiesByApp(WzBizType.GENERAL,1, 20);
			if(wzQueryEntitiesByAppResult.getCode() == 0){
				List<WzEntity> wzEntities = wzQueryEntitiesByAppResult.getWzEntities();
				System.out.println("查询所有实体成功:"+wzEntities.toString());
			} else{
				System.out.println("查询所有实体失败：（"+wzQueryEntitiesByAppResult.getCode()+"）"+wzQueryEntitiesByAppResult.getMessage());
			}
		} catch (WzException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
		//删除实体
		try {
			WzDeleteEntityResult wzDeleteEntityResult = wzEntityManager.deleteEntity(WzBizType.GENERAL,entityName);
			if(wzDeleteEntityResult.getCode() == 0){
				//tp
				System.out.println("删除实体成功:"+"实体A");
			} else{
				System.out.println("删除实体失败：（"+wzDeleteEntityResult.getCode()+"）"+wzDeleteEntityResult.getMessage());
			}
		} catch (WzException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		System.out.println("-----------实体管理-end-----------");	
	}
}